=== src/external/u3d/CMakeLists.txt ===
set (U3D_DIR ${CMAKE_CURRENT_SOURCE_DIR})

IF(APPLE)
	ADD_DEFINITIONS( -DMAC32 -fno-strict-aliasing )
	SET( U3D_PLATFORM Mac32 )
ENDIF(APPLE)

IF(WIN32)
	ADD_DEFINITIONS( -DUNICODE -D_UNICODE -D_CRT_SECURE_NO_DEPRECATE )
	SET( U3D_PLATFORM Win32 )
	LINK_LIBRARIES( winmm )
	UNSET( CMAKE_SHARED_LIBRARY_PREFIX )
	UNSET( CMAKE_SHARED_MODULE_PREFIX )
	UNSET( CMAKE_STATIC_LIBRARY_PREFIX )
	UNSET( CMAKE_IMPORT_LIBRARY_PREFIX )
ENDIF(WIN32)

IF(UNIX AND NOT APPLE)
	ADD_DEFINITIONS( -DLIN32 -fno-strict-aliasing )
	SET( U3D_PLATFORM Lin32 )
ENDIF(UNIX AND NOT APPLE)

#============================================================================
# zlib
#============================================================================

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(stdint.h    HAVE_STDINT_H)
check_include_file(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
	add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable

#
# Check for fseeko
#
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
	add_definitions(-DNO_FSEEKO)
endif()

#
# Check for unistd.h
#
check_include_file(unistd.h Z_HAVE_UNISTD_H)

if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
	add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
endif()

SET(ZLIB_SOURCE_DIR ${U3D_DIR}/src/RTL/Dependencies/zlib)
#configure_file(${ZLIB_SOURCE_DIR}/zconf.h.cmakein
#			   ${CMAKE_CURRENT_BINARY_DIR}/zconf.h @ONLY)
#include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${ZLIB_SOURCE_DIR})

set(ZLIB_PUBLIC_HDRS
	${ZLIB_SOURCE_DIR}/zconf.h
	${ZLIB_SOURCE_DIR}/zlib.h
)
set(ZLIB_PRIVATE_HDRS
	${ZLIB_SOURCE_DIR}/zconf.h
	${ZLIB_SOURCE_DIR}/crc32.h
	${ZLIB_SOURCE_DIR}/deflate.h
	${ZLIB_SOURCE_DIR}/gzguts.h
	${ZLIB_SOURCE_DIR}/inffast.h
	${ZLIB_SOURCE_DIR}/inffixed.h
	${ZLIB_SOURCE_DIR}/inflate.h
	${ZLIB_SOURCE_DIR}/inftrees.h
	${ZLIB_SOURCE_DIR}/trees.h
	${ZLIB_SOURCE_DIR}/zutil.h
)
set(ZLIB_SRCS
	${ZLIB_SOURCE_DIR}/adler32.c
	${ZLIB_SOURCE_DIR}/compress.c
	${ZLIB_SOURCE_DIR}/crc32.c
	${ZLIB_SOURCE_DIR}/deflate.c
	${ZLIB_SOURCE_DIR}/gzclose.c
	${ZLIB_SOURCE_DIR}/gzlib.c
	${ZLIB_SOURCE_DIR}/gzread.c
	${ZLIB_SOURCE_DIR}/gzwrite.c
	${ZLIB_SOURCE_DIR}/inflate.c
	${ZLIB_SOURCE_DIR}/infback.c
	${ZLIB_SOURCE_DIR}/inftrees.c
	${ZLIB_SOURCE_DIR}/inffast.c
	${ZLIB_SOURCE_DIR}/trees.c
	${ZLIB_SOURCE_DIR}/uncompr.c
	${ZLIB_SOURCE_DIR}/zutil.c
)


#============================================================================
# png
#============================================================================

if(NOT WIN32)
	find_library(M_LIBRARY
		NAMES m
		PATHS /usr/lib /usr/local/lib)
	if(NOT M_LIBRARY)
	message(STATUS
		"math library 'libm' not found - floating point support disabled")
	endif()
else()
	# not needed on windows
	set(M_LIBRARY "")
endif()

set(PNG_SOURCE_DIR ${U3D_DIR}/src/RTL/Dependencies/png)
#include_directories(${CMAKE_CURRENT_BINARY_DIR})

# OUR SOURCES
set(libpng_public_hdrs
	${PNG_SOURCE_DIR}/png.h
	${PNG_SOURCE_DIR}/pngconf.h
	${PNG_SOURCE_DIR}/pnglibconf.h
)
set(libpng_sources
	${libpng_public_hdrs}
	${PNG_SOURCE_DIR}/pngdebug.h
	${PNG_SOURCE_DIR}/pnginfo.h
	${PNG_SOURCE_DIR}/pngpriv.h
	${PNG_SOURCE_DIR}/pngstruct.h
	${PNG_SOURCE_DIR}/png.c
	${PNG_SOURCE_DIR}/pngerror.c
	${PNG_SOURCE_DIR}/pngget.c
	${PNG_SOURCE_DIR}/pngmem.c
	${PNG_SOURCE_DIR}/pngpread.c
	${PNG_SOURCE_DIR}/pngread.c
	${PNG_SOURCE_DIR}/pngrio.c
	${PNG_SOURCE_DIR}/pngrtran.c
	${PNG_SOURCE_DIR}/pngrutil.c
	${PNG_SOURCE_DIR}/pngset.c
	${PNG_SOURCE_DIR}/pngtrans.c
	${PNG_SOURCE_DIR}/pngwio.c
	${PNG_SOURCE_DIR}/pngwrite.c
	${PNG_SOURCE_DIR}/pngwtran.c
	${PNG_SOURCE_DIR}/pngwutil.c
)
# SOME NEEDED DEFINITIONS

if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
endif(MSVC)

set(ADDITIONAL_LIBRARIES ${ADDITIONAL_LIBRARIES} ${M_LIBRARY})
include_directories(${PNG_SOURCE_DIR})

CHECK_INCLUDE_FILE(stdlib.h HAVE_STDLIB_H)

set(JPEG_SOURCE_DIR ${U3D_DIR}/src/RTL/Dependencies/jpeg)
#configure_file(${JPEG_SOURCE_DIR}/jconfig.h.cmake
#			   ${CMAKE_CURRENT_BINARY_DIR}/jconfig.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${JPEG_SOURCE_DIR})

if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

set(JPEG_PUBLIC_HDRS
	${JPEG_SOURCE_DIR}/jconfig.h
	${JPEG_SOURCE_DIR}/jerror.h
	${JPEG_SOURCE_DIR}/jmorecfg.h
	${JPEG_SOURCE_DIR}/jpeglib.h
	${JPEG_SOURCE_DIR}/jconfig.h
)
set(JPEG_PRIVATE_HDRS
	${JPEG_SOURCE_DIR}/cderror.h
	${JPEG_SOURCE_DIR}/jdct.h
	${JPEG_SOURCE_DIR}/jinclude.h
	${JPEG_SOURCE_DIR}/jmemsys.h
	${JPEG_SOURCE_DIR}/jpegint.h
	${JPEG_SOURCE_DIR}/jversion.h
	${JPEG_SOURCE_DIR}/transupp.h
)

# memmgr back ends: compile only one of these into a working library
# (For now, let's use the mode that requires the image fit into memory.
# This is the recommended mode for Win32 anyway.)
SET(JPEG_systemdependent_SRCS ${JPEG_SOURCE_DIR}/jmemnobs.c)

set(JPEG_SRCS
	${JPEG_SOURCE_DIR}/jaricom.c
	${JPEG_SOURCE_DIR}/jcapimin.c
	${JPEG_SOURCE_DIR}/jcapistd.c
	${JPEG_SOURCE_DIR}/jcarith.c
	${JPEG_SOURCE_DIR}/jccoefct.c
	${JPEG_SOURCE_DIR}/jccolor.c
	${JPEG_SOURCE_DIR}/jcdctmgr.c
	${JPEG_SOURCE_DIR}/jchuff.c
	${JPEG_SOURCE_DIR}/jcinit.c
	${JPEG_SOURCE_DIR}/jcmainct.c
	${JPEG_SOURCE_DIR}/jcmarker.c
	${JPEG_SOURCE_DIR}/jcmaster.c
	${JPEG_SOURCE_DIR}/jcomapi.c
	${JPEG_SOURCE_DIR}/jcparam.c
	${JPEG_SOURCE_DIR}/jcprepct.c
	${JPEG_SOURCE_DIR}/jcsample.c
	${JPEG_SOURCE_DIR}/jctrans.c
	${JPEG_SOURCE_DIR}/jdapimin.c
	${JPEG_SOURCE_DIR}/jdapistd.c
	${JPEG_SOURCE_DIR}/jdarith.c
	${JPEG_SOURCE_DIR}/jdatadst.c
	${JPEG_SOURCE_DIR}/jdatasrc.c
	${JPEG_SOURCE_DIR}/jdcoefct.c
	${JPEG_SOURCE_DIR}/jdcolor.c
	${JPEG_SOURCE_DIR}/jddctmgr.c
	${JPEG_SOURCE_DIR}/jdhuff.c
	${JPEG_SOURCE_DIR}/jdinput.c
	${JPEG_SOURCE_DIR}/jdmainct.c
	${JPEG_SOURCE_DIR}/jdmarker.c
	${JPEG_SOURCE_DIR}/jdmaster.c
	${JPEG_SOURCE_DIR}/jdmerge.c
	${JPEG_SOURCE_DIR}/jdpostct.c
	${JPEG_SOURCE_DIR}/jdsample.c
	${JPEG_SOURCE_DIR}/jdtrans.c
	${JPEG_SOURCE_DIR}/jerror.c
	${JPEG_SOURCE_DIR}/jfdctflt.c
	${JPEG_SOURCE_DIR}/jfdctfst.c
	${JPEG_SOURCE_DIR}/jfdctint.c
	${JPEG_SOURCE_DIR}/jidctflt.c
	${JPEG_SOURCE_DIR}/jidctfst.c
	${JPEG_SOURCE_DIR}/jidctint.c
	${JPEG_SOURCE_DIR}/jquant1.c
	${JPEG_SOURCE_DIR}/jquant2.c
	${JPEG_SOURCE_DIR}/jutils.c
	${JPEG_SOURCE_DIR}/jmemmgr.c)

SET(DEPENDENCIES_SRCS
	${ZLIB_SRCS}
	${ZLIB_PUBLIC_HDRS}
	${ZLIB_PRIVATE_HDRS}
	${libpng_sources}
	${JPEG_systemdependent_SRCS}
	${JPEG_SRCS}
	${JPEG_PUBLIC_HDRS}
	${JPEG_PRIVATE_HDRS})
#====


INCLUDE_DIRECTORIES(
	${U3D_DIR}/src/RTL/Component/Include
	${U3D_DIR}/src/RTL/Kernel/Include
	${U3D_DIR}/src/RTL/Platform/Include)
SET( Component_HDRS
	${U3D_DIR}/src/RTL/Component/Include/CArrayList.h
	${U3D_DIR}/src/RTL/Component/Include/DX7asDX8.h
	${U3D_DIR}/src/RTL/Component/Include/IFXACContext.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAdaptiveMetric.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAnimationModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXArray.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAttributes.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthor.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODAccess.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODGen.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODMesh.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODResource.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorGeomCompiler.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSet.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSetAccess.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSetAnalyzer.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSetResource.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorMesh.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorMeshMap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorMeshScrub.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorPointSet.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorPointSetAccess.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorPointSetResource.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorUpdate.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAutoPtr.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBaseOpenGL.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBitStreamCompressedX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBitStreamX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlendParam.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlockReaderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlockTypes.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlockWriterX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBones.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBonesManager.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoneWeightsModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundHierarchy.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundHierarchyMgr.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundingBox.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundSphereDataElement.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundVolume.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBTTHash.h
	${U3D_DIR}/src/RTL/Component/Include/IFXClock.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCLODManagerInterface.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCLODModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoincidentVertexMap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCollection.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoreCIDs.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoreServices.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoreServicesRef.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCornerIter.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataBlock.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataBlockQueueX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataBlockX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataPacket.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDecoderChainX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDecoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDeque.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDevice.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDidRegistry.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDids.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDirectX7.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDirectX8.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDummyModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXEncoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXEnums.h
	${U3D_DIR}/src/RTL/Component/Include/IFXErrorInfo.h
	${U3D_DIR}/src/RTL/Component/Include/IFXEuler.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExportingCIDs.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExportingInterfaces.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExportOptions.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExtensionDecoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExtensionEncoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFace.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFastAllocator.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFastHeap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFatCornerIter.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFileReference.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFrustum.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGenerator.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGlyph2DCommands.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGlyph2DModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGlyphCommandList.h
	${U3D_DIR}/src/RTL/Component/Include/IFXHash.h
	${U3D_DIR}/src/RTL/Component/Include/IFXHashMap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXHistogramDynamic.h
	${U3D_DIR}/src/RTL/Component/Include/IFXIDManager.h
	${U3D_DIR}/src/RTL/Component/Include/IFXImageCodec.h
	${U3D_DIR}/src/RTL/Component/Include/IFXImportingCIDs.h
	${U3D_DIR}/src/RTL/Component/Include/IFXImportingInterfaces.h
	${U3D_DIR}/src/RTL/Component/Include/IFXInet.h
	${U3D_DIR}/src/RTL/Component/Include/IFXInstant.h
	${U3D_DIR}/src/RTL/Component/Include/IFXInterleavedData.h
