=== debian/changelog ===
meshlab (2022.02+dfsg1-1) unstable; urgency=medium

  [ Rylie Pavlik ]
  * New upstream version 2022.02+dfsg1
    - Closes: #990401
    - meshlabserver tool removed
    - filter_csg and globalregistration plugins removed
    - filter_icp, filter_mesh_booleans, filter_texture_defragmentation,
      io_e57, and io_gltf plugins added
  * Updates for revised directory structure in newer upstream releases
  * Revise/update patches
    - Add 0008-e57-Fix-build-error-from-missing-include.patch to fix build.
    - Add 0009-Fix-spelling-errors-in-strings.patch to fix spelling errors
      in binaries.
    - Drop 0009-cmake-Search-for-use-Qt5Qml-in-a-more-graceful-absen.patch:
      Qt5Qml no longer required.
    - Drop 0010-build-Use-C99-where-available-for-large-file-support.patch:
      merged upstream.
    - Drop 16_shadersdir.patch: equivalent fixes applied upstream
    - Revise 03_disable-updates.patch.
    - Revise 22_find-plugins.patch.
  * d/copyright: Update, correct issues noticed by lintian and lrc.
  * d/control:
    - Update list of file formats in description.
    - Drop Build-Depends on libqt5xmlpatterns5-dev, qtdeclarative5-dev,
      qtscript5-dev, libbz2-dev, libchealpix-dev, libcfitsio-dev
    - Add Build-Depends on libxerces-c-dev, libcgal-dev, libboost-all-dev
  * d/rules: Update configure flags, build process, put deps from plugins
    in "Recommends" not "Depends".
  * d/get-orig-source.sh: Fix for changed tag format.
  * d/watch: Fix
  * d/source/lintian-overrides: Remove obsolete override
  * d/meshlab.lintian-overrides: Override RPATH error.
  * Use upstream's desktop file.
  * Fix reproducible builds. See: #1001870
    Thanks to Vagrant Cascadian for the patch.
  * Fix packager's name.

  [ Stuart Prescott ]
  * Update lintian overrides to new format.
  * d/rules: Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Rylie Pavlik <rylie@ryliepavlik.com>  Thu, 12 Dec 2024 10:11:53 -0600

meshlab (2020.09+dfsg1-3) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * Bump debhelper version to 13.

 -- Alex Myczko <tar@debian.org>  Thu, 18 Jul 2024 17:05:39 +0000

meshlab (2020.09+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Set C++14 explicitly. (Closes: #984232)

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Dec 2021 19:58:20 +0100
