=== debian/control ===
Source: meshlab
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rylie Pavlik <rylie@ryliepavlik.com>,
           Teemu Ikonen <tpikonen@gmail.com>,
           Alex Myczko <tar@debian.org>
Section: graphics
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               lib3ds-dev,
               libboost-all-dev,
               libcgal-dev,
               libeigen3-dev,
               libglew-dev,
               libglu1-mesa-dev,
               libgmp-dev,
               libjpeg-dev,
               libmuparser-dev,
               libopenctm-dev,
               libpng-dev,
               libqhull-dev,
               libqt5opengl5-desktop-dev,
               libxerces-c-dev,
               mesa-common-dev,
               qtbase5-dev,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/meshlab
Vcs-Git: https://salsa.debian.org/science-team/meshlab.git
Homepage: https://www.meshlab.net/
Rules-Requires-Root: no

Package: meshlab
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: chemical-mime-data,
            ${pluginshlibs:Recommends}
Description: System for processing and editing triangular meshes
 This is an open source, portable, and extendible system for the
 processing and editing of unstructured 3D triangular meshes.
 The system is aimed to help the processing of the typical not-so-small
 unstructured models arising in 3D scanning, providing a set of tools for
 editing, cleaning, healing, inspecting, rendering and converting this kind
 of meshes.
 .
 Meshlab can read and write files in a variety of formats. Supported formats
 for meshes include:
 .
 - 3DS aka 3D-Studio File Format (read/write)
 - ASC aka ascii triplets of points (read)
 - BRE aka Breuckmann File Format (read)
 - CTM aka OpenCTM compressed format (read/write)
 - DAE aka COLLADA (read/write)
 - DXF (write)
 - E57 points cloud (read/write)
 - FBX Autodesk Interchange Format(read)
 - glTF/glb aka GL Transmission Format 2.0 (binary or ascii) (read)
 - JSON (write)
 - OBJ aka Alias Wavefront Object (read/write)
 - OFF aka Object File Format (read/write)
 - PDB aka Protein Data Bank(read)
 - PLY aka Stanford Polygon File Format (read/write)
 - PTX (read)
 - QOBJ aka Quad Object (read)
 - STL (read/write)
 - TRI aka photogrammetric reconstructions (read)
 - TXT aka generic ASCII point list or image list file (read)
 - U3D/IDTF (write)
 - VMI aka VCG Dump File Format (read)
 - WRL aka VRML 2.0 (read/write)
 - X3D aka X3D in XML encoding (read/write)
 - X3DV aka X3D in VRML encoding (read)
 - XYZ Point Cloud (with or without normal) (read/write)
 - apts aka Expe's point set (ascii) (read)
 - pts aka Expe's point set (binary) (read)
 .
 Project formats include:
 .
 - MLP aka MeshLab Project (read/write)
 - MLB aka MeshLab Binary Project (read/write)
 - ALN aka Align Project (read)
 - OUT aka Bundler Output (read)
 - NVM aka VisualSFM Output (read)
 .
 A variety of image formats are also supported.
